//DEA testing bloody flipping nuisance 

extern int        Slow_Period = 17;  // Slow MA value
extern int        Fast_Period = 13;  // Fast MA value
extern int        MA_Mode = 1;       // MA Mode [ 0 = SMA | 1 = EMA | 2 = SMMA | 3 = LWMA ]
extern double     Lots = 1.0;        // Lot size
extern int        slippage = 1;      // Slippage value


double Slow_Direction, Fast_Direction;
double SlowMA, FastMA;

double dXPoint = 1;

int Prev_Bars, Ticket_Number, Exisiting_Position_Type;
int CrossOver_Up = 0, CrossOver_Down = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   
   Exisiting_Position_Type = 0;  // Open positions will have a value of: 0 = no position | 1 = A Long position is open | 2 = A Short position open
   Prev_Bars = Bars;
  
   if(Digits == 3 || Digits == 5) // Check the data feed pricing model 3 or 5 decimal places
   {
      dXPoint = 10;
      slippage = slippage * dXPoint; // Adjust slippage variable to account for 5th decimal place reading
   }

  return(0);
}

int start()

{ 

  if(Bars != Prev_Bars)
  { 
  
//+------------------------------------------------------------------+
//| Price algo below                                                 |
//+------------------------------------------------------------------+
  
   SlowMA = iMA(NULL, 0, Slow_Period, 0, MA_Mode, PRICE_CLOSE,0);
   FastMA = iMA(NULL, 0, Fast_Period, 0, MA_Mode, PRICE_CLOSE,0);
      
   Slow_Direction = SlowMA;
   Fast_Direction = FastMA;

  
//+------------------------------------------------------------------+
//| Open and Close order functions below                             |
//+------------------------------------------------------------------+
 
   if (Fast_Direction > Slow_Direction) // Check the value of the MA's.  If the fast MA is > the slow MA then we have a cross over UPWARDS
   {
    if (CrossOver_Up == 0) // If the above is true, then check that the last cross over was NOT UPWARDS otherwise multiple orders will be triggered
    {
     CrossOver_Up = 1;  // If the above is true then set this variable to 1 as it crossed UPWARDS ...
     CrossOver_Down = 0; // ... and also set this variable to 0 - it DIDN'T CROSS DOWN
     
     // Below, the code checks for an existing open position and will close it if the open position is a SHORT 
     
     if ( Exisiting_Position_Type == 2 ) // Is the existing position a SHORT (type 2)?.  If so ...
     {
         closeShort(); // ... then close the open position.
     } 
     
     openLong(); // Now go and open a LONG order
     } 
    }
   
   
   else if (Fast_Direction < Slow_Direction) // Check the value of the MA's.  If the fast MA is < the slow MA then we have a cross over DOWN
   {
    if ( CrossOver_Down == 0) // If the above is true, then check that the last cross over was NOT DOWN otherwise multiple orders will be triggered
    {
     CrossOver_Down = 1; // If the above is true then set this variable to 1 as it crossed DOWN ...
     CrossOver_Up = 0; // ... and also set this variable to 0 - it DIDN'T CROSS UPWARDS
          

     // Below, the code checks for an existing open position and will close it if the open position is a LONG 
     
      if ( Exisiting_Position_Type == 1 ) // Is the existing position a LONG (type 1)?.  If so ...
      {
         closeLong(); // ... then close the open position.
      } 
      
      openShort(); // Now go and open a SHORT order
      }
     }
    }
   
return(0);
}


void closeShort()
{
 OrderClose(Ticket_Number, Lots, Ask, slippage, White);
 Exisiting_Position_Type = 0; // There are no open positions so set this to 0
}

void closeLong()
{
 OrderClose(Ticket_Number, Lots, Bid, slippage, White);
 Exisiting_Position_Type = 0; // There are no open positions so set this to 0
}

void openShort()
{
 Ticket_Number = OrderSend(Symbol(), OP_SELL, Lots, Bid, slippage, 0, 0, NULL, 0, 0, Red);
 Exisiting_Position_Type = 2;  // The open position is now a SHORT so set this to 2
}

void openLong()
{
 Ticket_Number = OrderSend(Symbol(), OP_BUY, Lots, Ask, slippage, 0, 0, NULL, 0, 0, Green);  // Execute Buy order
 Exisiting_Position_Type = 1; // The open postion is now a LONG so set this to 1
}